-- main for ls.love

function love.load()
	gr, li, pi, ky			= love.graphics, love.image, math.pi,love.keyboard
	gr.setCaption( 'lifesaver' )
	smallfont				= gr.newFont(18)
	gr.setFont( smallfont )
	image					= gr.newImage( 'MyTest1.jpg')
	ls = {
		size				= 100,
		sides				=   5,
		angle				=   0,
		thickness			=   0.6,
		color				=   3,
		circle				= 2 * pi + pi / 16,
		x					= gr.getWidth() / 2,
		y					= gr.getHeight() / 2,
		}
	info = {
			"Keyboard Controls",
			"size:",
			"  <q><w>",
			"# sides:",
			"  <a><s>",
			"location:",
			"  <left><right>",
			"  <up><down>",
			"thickness:",
			"  <z><x>",
			"color:",
			"  <c><v>"
			}
	colors	= {
		{ 255, 255, 255, 255 },
		{   0,   0,   0, 255 },
		{ 255,   0,   0, 255 },
		{   0, 255,   0, 255 },
		{   0,   0, 255, 255 },
		{ 155, 155, 155, 185 }}
	end

function love.draw()
	gr.setColorMode( 'replace' )
	gr.draw( image )
	draw_object()
	key_options()
	show_data()
	gr.print( 'FPS: '..love.timer.getFPS(), gr.getWidth()-100, 10 )
	end

function love.update( dt )
	ls.angle		=  ls.angle + dt
	if ky.isDown('left')	then ls.x = ls.x - 1		end
	if ky.isDown('right')	then ls.x = ls.x + 1		end
	if ky.isDown( 'up'	)	then ls.y = ls.y - 1		end
	if ky.isDown('down')	then ls.y = ls.y + 1		end
	if ky.isDown('z')		then ls.thickness = ls.thickness + .001	end
	if ky.isDown('x')		then ls.thickness = ls.thickness - .001	end
	if ky.isDown('q')		then ls.size	= ls.size - 1			end
	if ky.isDown('w')		then ls.size	= ls.size + 1			end

	end

function love.keypressed( key )
	if key == 'escape'	then love.event.push('quit') 								end
	if key == 's'		then ls.sides	= ls.sides < 20	and ls.sides + 1	or 20	end
	if key == 'a'		then ls.sides	= ls.sides >  3	and ls.sides - 1	or 3	end
	if key == 'v'		then ls.color	= ls.color < #colors and ls.color+1 or 1	end
	if key == 'c'		then ls.color	= ls.color > 1 and ls.color -1 or #colors	end
	end

function key_options()
	gr.setColor( 155, 155, 155, 255 )
	for i = 1, #info do gr.print( info[i], 10, i * 20 ) end
	end

function show_data()
	data = {
		"Settings",
		"sides: "..ls.sides,
		"size: "..ls.size,
		"thickness: "..ls.thickness,
		"X position: "..ls.x,
		"Y position: "..ls.y,
		"rotation angle: "..math.floor(ls.angle*180/pi),
		}
	local x, y = 10, 20
	for i = 1, #data do
		gr.print( data[i], x, i * y + 420 )
		end
	end

function draw_object()
	local arco, arci		= {}, {}	-- tables for inner & outer points
	local val				= 1
	for i = ls.angle, ls.angle+ls.circle, 2*pi/ls.sides do
		local xo			= ls.size * math.cos(i) + ls.x
		local yo			= ls.size * math.sin(i) + ls.y
		local xi			= ls.size*ls.thickness * math.cos(i) + ls.x
		local yi			= ls.size*ls.thickness * math.sin(i) + ls.y
		arco[val]			= { xo, yo }
		arci[val]			= { xi, yi }
		val					= val + 1
		end
	gr.setColor(unpack(colors[ls.color]))
	for i = 1, #arco - 1 do		-- polygon can't handle all the points at once
		gr.polygon('fill',
			arco[i][1],	arco[i][2],	arco[i+1][1], arco[i+1][2],
			arci[i+1][1], arci[i+1][2], arci[i][1],	arci[i][2])
		end
	end
